PluginInstallEngine (Grails 2.3.8)
Date: 2014-04-24

Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## org.codehaus.groovy.grails.resolve
[Groovy] Class PluginInstallEngine

    java.lang.Object
      org.codehaus.groovy.grails.resolve.PluginInstallEngine

    class PluginInstallEngine
    extends java.lang.Object

Manages the installation and uninstallation of plugins from a Grails project.

Authors:
  Graeme Rocher

Since:
  1.3

Field Summary
`protected java.lang.Object` | `ant`
`protected java.lang.Object` | `applicationPluginsLocation`
`protected Metadata` | `metadata`
`protected PluginBuildSettings` | `pluginSettings`
`protected PluginResolveEngine` | `resolveEngine`
`protected BuildSettings` | `settings`

Property Summary
`static java.util.List` | `CORE_PLUGINS`
`groovy.lang.Closure` | `errorHandler`
`groovy.lang.Closure` | `eventHandler`
`java.util.List` | `installedPlugins` plugins that were installed in the last execution of installPlugin
`boolean` | `isInteractive`
`java.lang.Object` | `pluginDirVariableStore`
`groovy.lang.Closure` | `pluginScriptRunner`
`groovy.lang.Closure` | `postInstallEvent`
`groovy.lang.Closure` | `postUninstallEvent`

Constructor Summary
`PluginInstallEngine(BuildSettings settings, PluginBuildSettings pbs = GrailsPluginUtils.getPluginBuildSettings(settings, Metadata md = Metadata.getCurrent(, groovy.util.AntBuilder ant = new AntBuilder()`

Method Summary
`protected void` | `assertNoExistingInlinePlugin(java.lang.String name)`
`protected boolean` | `checkExistingPluginInstall(java.lang.String name, java.lang.Object version, java.io.File pluginZip, boolean isResolve = true)` Checks an existing plugin path to install and returns true if the installation should be aborted or false if it should continue
`void` | `checkPluginsToUninstall()`
`void` | `checkPluginsToUninstall(java.util.List pluginZips)`
`boolean` | `installPlugin(java.lang.String name, java.lang.String version = null)` Installs a plugin for the given name and optional version.
`boolean` | `installPlugin(java.io.File zipFile, boolean overwrite = false)` Installs a plugin from the given ZIP file
`boolean` | `installPlugin(java.net.URL zipURL)` Installs a plugin from the given URL
`protected boolean` | `installPluginZipInternal(java.lang.String name, java.lang.String version, java.io.File pluginZip, boolean overwrite = false, boolean isResolve = false)`
`protected boolean` | `installResolvePlugins(java.util.Collection pluginZips)`
`boolean` | `installResolvedPlugin(java.io.File zipFile)` Installs a plugin from the given ZIP file.
`boolean` | `installedResolvedPlugins()`
`boolean` | `isNotInlinePluginLocation(java.io.File pluginDir)` Check to see if the plugin directory is in plugins home.
`protected java.lang.Object` | `postInstall(java.lang.String pluginInstallPath)`
`protected java.lang.Object` | `postUninstall()`
`java.util.List` | `readMetadataFromZip(java.lang.String zipLocation)` Reads plugin metadata from a plugin zip file and returns a list containing the plugin name, version and XML metadata.
`GrailsPluginInfo` | `readPluginInfoFromZip(java.lang.String zipLocation)` Reads plugin info from the zip file location
`boolean` | `resolveAndInstallDepdendencies()`
`void` | `uninstallPlugin(java.lang.String name, java.lang.String version = null)` Uninstalls a plugin for the given name and optional version

Methods inherited from class java.lang.Object
java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Field Detail

### ant

    protected java.lang.Object ant

### applicationPluginsLocation

    protected java.lang.Object applicationPluginsLocation

### metadata

    protected Metadata metadata

### pluginSettings

    protected PluginBuildSettings pluginSettings

### resolveEngine

    protected PluginResolveEngine resolveEngine

### settings

    protected BuildSettings settings

Property Detail

### CORE_PLUGINS

    static final java.util.List CORE_PLUGINS

### errorHandler

    groovy.lang.Closure errorHandler

### eventHandler

    groovy.lang.Closure eventHandler

### installedPlugins

    java.util.List installedPlugins

  plugins that were installed in the last execution of installPlugin

### isInteractive

    boolean isInteractive

### pluginDirVariableStore

    java.lang.Object pluginDirVariableStore

### pluginScriptRunner

    groovy.lang.Closure pluginScriptRunner

### postInstallEvent

    groovy.lang.Closure postInstallEvent

### postUninstallEvent

    groovy.lang.Closure postUninstallEvent

Constructor Detail

### PluginInstallEngine

    PluginInstallEngine(BuildSettings settings, PluginBuildSettings pbs = GrailsPluginUtils.getPluginBuildSettings(settings, Metadata md = Metadata.getCurrent(, groovy.util.AntBuilder ant = new AntBuilder()

Method Detail

### assertNoExistingInlinePlugin

    protected void assertNoExistingInlinePlugin(java.lang.String name)

### checkExistingPluginInstall

    protected boolean checkExistingPluginInstall(java.lang.String name, java.lang.Object version, java.io.File pluginZip, boolean isResolve = true)

  Checks an existing plugin path to install and returns true if the installation should be aborted or false if it should continue If an error occurs the errorHandler is invoked.
  Parameters:
    `name` - The plugin name
    `version` - The plugin version
  Returns:
    true if the installation should be aborted

### checkPluginsToUninstall

    @groovy.transform.CompileStatic
    void checkPluginsToUninstall()

### checkPluginsToUninstall

    @groovy.transform.CompileStatic
    void checkPluginsToUninstall(java.util.List pluginZips)

### installPlugin

    boolean installPlugin(java.lang.String name, java.lang.String version = null)

  Installs a plugin for the given name and optional version.
  Parameters:
    `name` - The plugin name
    `version` - The plugin version (optional)
  Returns:
    true if installed and not cancelled by user

### installPlugin

    boolean installPlugin(java.io.File zipFile, boolean overwrite = false)

  Installs a plugin from the given ZIP file
  Parameters:
    `zipFile` - The plugin zip file

### installPlugin

    boolean installPlugin(java.net.URL zipURL)

  Installs a plugin from the given URL
  Parameters:
    `zipURL` - The zip URL

### installPluginZipInternal

    protected boolean installPluginZipInternal(java.lang.String name, java.lang.String version, java.io.File pluginZip, boolean overwrite = false, boolean isResolve = false)

### installResolvePlugins

    @groovy.transform.CompileStatic
    protected boolean installResolvePlugins(java.util.Collection pluginZips)

### installResolvedPlugin

    boolean installResolvedPlugin(java.io.File zipFile)

  Installs a plugin from the given ZIP file. Differs from #installPlugin(zipFile) in that the plugin to be installed is assumed to already be resolved and hence not placed in the users local cache
  Parameters:
    `zipFile` - The plugin zip file

### installedResolvedPlugins

    @groovy.transform.CompileStatic
    boolean installedResolvedPlugins()

### isNotInlinePluginLocation

    boolean isNotInlinePluginLocation(java.io.File pluginDir)

  Check to see if the plugin directory is in plugins home.

### postInstall

    protected java.lang.Object postInstall(java.lang.String pluginInstallPath)

### postUninstall

    protected java.lang.Object postUninstall()

### readMetadataFromZip

    java.util.List readMetadataFromZip(java.lang.String zipLocation)

  Reads plugin metadata from a plugin zip file and returns a list containing the plugin name, version and XML metadata. Designed for use with Groovy's multiple assignment operator
  Parameters:
    `zipLocation` - The zip location
  Returns:
    A list

### readPluginInfoFromZip

    GrailsPluginInfo readPluginInfoFromZip(java.lang.String zipLocation)

  Reads plugin info from the zip file location
  Parameters:
    `zipLocation` - The zip location
  Returns:

### resolveAndInstallDepdendencies

    @groovy.transform.CompileStatic
    boolean resolveAndInstallDepdendencies()

### uninstallPlugin

    void uninstallPlugin(java.lang.String name, java.lang.String version = null)

  Uninstalls a plugin for the given name and optional version
  Parameters:
    `name` - The plugin name
    `version` - The version

Groovy Documentation